--    This file is part of Alp gen.
--    Copyright 2021 Thomas "V10lator" Rohloff <v10lator@myway.de
--
--    Alp gen is free software: you can redistribute it and/or modify
--    it under the terms of the GNU General Public License as published by
--    the Free Software Foundation, either version 3 of the License, or
--    (at your option) any later version.
--
--    Alp gen is distributed in the hope that it will be useful,
--    but WITHOUT ANY WARRANTY; without even the implied warranty of
--    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--    GNU General Public License for more details.
--
--    You should have received a copy of the GNU General Public License
--    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.

local pipeUtil = require "V10lator/pipeUtil"

local scale = nil

local function saveData()
	if scale == nil then
		pipeUtil.init()
		local pipe = pipeUtil.open("alps_scale", "RECV")
		scale = pipeUtil.read(pipe)
		pipeUtil.close(pipe)
		pipeUtil.cleanup()
	end
	return { scale = scale }
end

local function loadData(state)
	if scale ~= nil or state == nil or state.scale == nil then
		return
	end
	
	scale = state.scale
	
	pipeUtil.init()
	local pipe = pipeUtil.open("alps_scale", "SEND")
	pipeUtil.write(pipe, scale)
	pipeUtil.close(pipe)
	pipeUtil.cleanup()
end

function data()
	return {
		save = saveData,
		load = loadData,
		update = function() end,
		guiHandleEvent = function (id, name, param) end,
		handleEvent = function (id, name, param) end
	}
end
