--    This file is part of Alp gen.
--    Copyright 2021 Thomas "V10lator" Rohloff <v10lator@myway.de
--
--    Alp gen is free software: you can redistribute it and/or modify
--    it under the terms of the GNU General Public License as published by
--    the Free Software Foundation, either version 3 of the License, or
--    (at your option) any later version.
--
--    Alp gen is distributed in the hope that it will be useful,
--    but WITHOUT ANY WARRANTY; without even the implied warranty of
--    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--    GNU General Public License for more details.
--
--    You should have received a copy of the GNU General Public License
--    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.

local data = {}

function data.write(key, value)
	if game.v10lator == nil then
		game.v10lator = {}
	end
	table.insert(game.v10lator, { key = key, value = value })
end

function data.readTable(tbl, name)
	print(name .. ":")
	for tk,tv in pairs(tbl) do
		local tt = type(tv)
		if tt == "table" then
			data.readTable(tv, name .. "/" .. tk)
		elseif tt == "userdata" then
			print(name .. "/" .. tk .. ": userdata")
		elseif tt == "function" then
			print(name .. "/" .. tk .. ": function")
		elseif tv == true then
			print(name .. "/" .. tk .. ": true")
		elseif tv == false then
			print(name .. "/" .. tk .. ": false")
		elseif tv == nil then
			print(name .. "/" .. tk .. ": nil")
		else
			print(name .. "/" .. tk .. ": " .. tv)
		end
	end
end

function data.read(key)

	for k,v in pairs(_G) do
		if k ~= "package" and k ~= "_G" then
			if type(v) == "table" then
				data.readTable(v, k)
			elseif v == true then
				print(k .. ": true")
			elseif v == false then
				print(k .. ": false")
			elseif type(v) == "userdata" then
				print(k .. ": userdata")
			elseif type(v) == "function" then
				print(k .. ": function")
			elseif v == nil then
				print(k .. ": nil")
			else
				print(k .. ": " .. v)
			end
		end
	end
	
	if game.v10lator ~= nil then
		for entry in game.v10lator do
			if entry.key == key then
				return entry.value
			end
		end
	end

--	local tk = "V10lator_metadata_" .. key
--	for tbl in game.config.cargotypes do
--		if tbl.id == tk then
--			return tbl.name
--		end
--	end
	return nil
end

return data
