--    This file is part of Alp gen.
--    Copyright 2021 Thomas "V10lator" Rohloff <v10lator@myway.de
--
--    Alp gen is free software: you can redistribute it and/or modify
--    it under the terms of the GNU General Public License as published by
--    the Free Software Foundation, either version 3 of the License, or
--    (at your option) any later version.
--
--    Alp gen is distributed in the hope that it will be useful,
--    but WITHOUT ANY WARRANTY; without even the implied warranty of
--    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--    GNU General Public License for more details.
--
--    You should have received a copy of the GNU General Public License
--    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.

local data = {}

data.isLinux = package.cpath:match("%p[\\|/]?%p(%a+)") ~= "dll"
data.shell = nil

function data.init()
	if data.shell ~= nil then
		return
	end
	
	if data.isLinux then
		data.shell = io.popen("/bin/sh -s", "w")
		data.shell:setvbuf("no")
		data.shell:write("rm  -f \"/tmp/v10lator_namedPipe_*\"\n")
		data.shell:flush()
	else
		data.shell = io.popen("cmd", "w")
		data.shell:setvbuf("no")
		data.shell:write("@echo off\r\n")
		data.shell:write("del \"%TEMP%\v10lator_namedPipe_*\"\r\n")
		data.shell:flush()
	end
end

function data.cleanup()
	if data.shell == nil then
		return
	end
	
	if data.isLinux then
		data.shell:write("rm  -f \"/tmp/v10lator_namedPipe_*\"\n")
	else
		data.shell:write("del \"%TEMP%\v10lator_namedPipe_*\"\r\n")
	end
	
	data.shell:flush()
	data.shell:close()
	data.shell = nil
end

function data.reset(file)
	if data.isLinux then
		data.shell:write("rm \"" .. file.name .. "\"\n")
	else
		data.shell:write("del \"" .. file.name .. "\"\r\n")
	end
	data.shell:flush()
end

function data.open(name, mode)
	if mode ~= "SEND" and mode ~= "RECV" then
		return nil
	end
	
	local ret = {}
	ret.mode = mode
	
	if data.isLinux then
		ret.name = "/tmp/v10lator_namedPipe_" .. name
	else
		ret.name = "%TEMP%\v10lator_namedPipe_" .. name
	end
	
	if mode == "SEND" then
		data.reset(ret)
	end
	
	return ret
end

function data.close(file)
	if file.mode == "RECV" then
		data.reset(file)
	end
	file.mode = "INVALID"
end

function data.write(file, dta)
	local pipe
	repeat
		pipe = io.open(file.name)
		if pipe ~= nil then
			pipe:close()
		end
	until( pipe == nil)
	
--	pipe = io.open(file.name, "w")
--	pipe:write(dta)
--	pipe:flush()
--	pipe:close()
	
	if data.isLinux then
		data.shell:write("echo -e -n \"" .. dta .. "\" > \"" .. file.name .. "\"\n")
	else
		data.shell:write("echo | set /p \"" .. dta .. "\" > \"" .. file.name .. "\"\r\n")
	end
	data.shell:flush()
end

function data.read(file)
	local ret = nil
	do
		local tf = io.open(file.name)
		if tf ~= nil then
			ret = tf:read("*a")
			tf:close()
		end
	end
	
	if ret ~= nil then
		data.reset(file)
	end
	
	return ret
end

return data
